import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;

import javax.swing.JLabel;
import javax.swing.SwingUtilities;
import javax.swing.border.BevelBorder;

import org.jdesktop.animation.timing.Animator;
import org.jdesktop.animation.timing.TimingTarget;
import org.jdesktop.animation.timing.TimingTargetAdapter;
import org.jdesktop.animation.timing.interpolation.PropertySetter;

public class TimingSample5 extends BasicSample {

    private JLabel label;

    private Animator animator;

    public TimingSample5() {
        super();

        label = new JLabel("Property Change!");
        label.setFont(new Font("San-Serif", Font.BOLD, 24));
        label.setBorder(new BevelBorder(BevelBorder.RAISED));
        label.setOpaque(true);

        frame.add(label, BorderLayout.CENTER);
        frame.setSize(new Dimension(400, 140));
        frame.setVisible(true);
        
        setAnimator();
    }

    private void setAnimator() {
        Color orig1 = label.getBackground();
        animator = PropertySetter.createAnimator(5000, label, "background", 
                                                 orig1, Color.BLUE, Color.YELLOW, Color.RED, orig1);
        Color orig2 = label.getForeground();
        PropertySetter setter = new PropertySetter(label, "foreground", 
                                                   orig2, Color.PINK, Color.MAGENTA, Color.CYAN, orig2);
        animator.addTarget(setter);

        TimingTarget target = new TimingTargetAdapter() {
                public void end() {
                    clear();
                }
            };
        animator.addTarget(target);
    }

    @Override
    protected void start() {
        animator.start();
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    new TimingSample5();
                }
            });
    }
}
